import { MatcherAdCreationFailedMessageHandler } from '@modules/ad/interface/message-handlers/matcher-ad-creation-failed.message-handler';
import { CommandBus } from '@nestjs/cqrs';
import { Test, TestingModule } from '@nestjs/testing';

const matcherAdCreationFailedMessage =
  '{"id":"4eb6a6af-ecfd-41c3-9118-473a507014d4"}';

const mockCommandBus = {
  execute: jest.fn(),
};

describe('Matcher Ad Creation Failed Message Handler', () => {
  let matcherAdCreationFailedMessageHandler: MatcherAdCreationFailedMessageHandler;

  beforeAll(async () => {
    const module: TestingModule = await Test.createTestingModule({
      providers: [
        {
          provide: CommandBus,
          useValue: mockCommandBus,
        },
        MatcherAdCreationFailedMessageHandler,
      ],
    }).compile();

    matcherAdCreationFailedMessageHandler =
      module.get<MatcherAdCreationFailedMessageHandler>(
        MatcherAdCreationFailedMessageHandler,
      );
  });

  afterEach(async () => {
    jest.clearAllMocks();
  });

  it('should be defined', () => {
    expect(matcherAdCreationFailedMessageHandler).toBeDefined();
  });

  it('should invalidate an ad', async () => {
    jest.spyOn(mockCommandBus, 'execute');
    await matcherAdCreationFailedMessageHandler.matcherAdCreationFailed(
      matcherAdCreationFailedMessage,
    );
    expect(mockCommandBus.execute).toHaveBeenCalledTimes(1);
  });
});
